Subject: Walking forward is sometimes interrupted by one or two backward steps
Description

This can happen from a stand still or in the middle of walking forward.  It appears to be related to your actual cadence, your trigger
cadence, and the timing between the two hall effect sensors.  More research will need to be done to determine the underlying cause.

History
01/13/2017 09:45 pm - J. Simmons

I believe I have figured out what is causing this issue.  In void HandleWalking() I decided to reuse the void InitializeWalkingVariables() method to
implement the branch of code that handles the case when a user stops walking.

InitializeWalkingVariables() has several side effects I did not consider when I made this decision, not the least of which is it wipes out all data about the
cadence and its direction.  So, if a user is pedaling very close to the trigger cadence and happens to slow down below the trigger cadence while the
magnet is between the sensors, then the cadence and its direction are zeroed out.  The next events the Holoseat sees are the direction sensor
followed by the cadence sensor.  This condition indicates walking backwards and tada you get a step or two backwards.  Once the user gets back up
to the trigger cadence the walking forward state is established again and their character moves forward.

I tested this theory last night by ensuring I was always pedaling faster than I needed to.  At no point during that testing did I see this issue.  However,
later I resumed normal play and this issue presented itself.

I believe the fix is to simplify the response to the state transitioning to stopped walking since we want to hold on to cadence and direction to avoid this
issue.  My first test will be to simply release all of the keys and set the walking state to false.

01/13/2017 11:05 pm - J. Simmons

Probable fix committed to revision r54 per comment above.  New side effect of pedaling near the trigger cadence is the occasional stop and go motion
(which is exactly what should happen when you pedal around and below the trigger cadence).

Going to leave this issue open for a few days while Bryan and I both test out the fix.  But, I am feeling very good about it.

01/19/2017 05:29 am - J. Simmons
- Status changed from New to Resolved

Bryan and I have done more testing with no sign of this bug. Marking it as resolved.
